// HookKeyHookApp.cpp: CHookKeyHookApp NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "HookKeyHookApp.h"
#include "HKHCommon.h"
#include "HookKeyHook.h"

/* Defines */
#define		HOOKKEYHOOK_WINDOW_TITLE		_T("HookKeyHook Window")
#define		HOOKKEYHOOK_WINDOW_CLASS		_T("HookKeyHook Window Class")

#define		DENWA_WINDOW_TITLE				_T("db ")
#define		SHPHONEAPP_REG_PATH				_T("Software\\Sharp\\PhoneApp")
#define		LOCKPHONE_REG_VALUE_NAME		_T("LockPhone")
#define		PHONESTATUS_REG_KEY				_T("Software\\Sharp\\PhoneStatus")
#define		PHONESTATUS0_REG_VALUE_NAME		_T("Status0")

#define		WM_NOTIFY_HKHEVENT				(WM_USER + 1)
#define		TIMERID_ONHOOK					1
#define		TIMERID_OFFHOOK					2

#define		HOOKKEYHOOK_CMDSTR_SENDKEY		_T("sendkey")
#define		HOOKKEYHOOK_CMDSTR_ONHOOK		_T("onhook")
#define		HOOKKEYHOOK_CMDSTR_OFFHOOK		_T("offhook")
#define		HOOKKEYHOOK_CMD_SENDKEY			1
#define		HOOKKEYHOOK_CMD_ONHOOK			2
#define		HOOKKEYHOOK_CMD_OFFHOOK			3
#define		MAX_KEYSEQNUM					2

/* ProtoTypes */
static LRESULT CALLBACK WndProc(HWND, UINT,	WPARAM,	LPARAM);


// WXgDWORDlǂݍ
static
BOOL
ReadRegDWORD(
	HKEY	hKey,
	LPTSTR	pSubKey,
	LPTSTR	pValueName,
	LPDWORD	pdwValue
)
{
	BOOL	bRet;
	LRESULT lResult;
	HKEY	hSubKey = NULL;

	bRet = FALSE;

	if (hKey == NULL || pSubKey == NULL || pValueName == NULL || pdwValue == NULL) {
		return FALSE;
	}

	lResult = RegOpenKeyEx(hKey, pSubKey, 0, KEY_ALL_ACCESS, &hSubKey);
	if (lResult == ERROR_SUCCESS) {
		DWORD	dwType = REG_DWORD;
		DWORD	dwValue = 0;
		DWORD	dwSize = 0;

		dwSize = sizeof(dwValue);
		lResult = RegQueryValueEx(hSubKey, pValueName, NULL, &dwType, (LPBYTE)&dwValue, &dwSize);
		if (lResult == ERROR_SUCCESS) {
			*pdwValue = dwValue;
			bRet = TRUE;
		}

		CloseHandle(hSubKey);
		hSubKey = NULL;
	}

	return bRet;
}


// dbłIbL[tbN邩H(WXgݒlǂݍ)
static
BOOL
IsForceHookOnHook()
{
	BOOL	bRet;
	DWORD	dwValue = 0;

	bRet = FALSE;

	if (ReadRegDWORD(HKEY_CURRENT_USER, HOOKKEYHOOK_SETTING_REGKEY, HOOKKEYHOOK_FORCEHOOK_ONHOOK, &dwValue)) {
		if (dwValue != 0) {
			bRet = TRUE;
		}
	}

	return bRet;
}


// dbłʘbL[tbN邩H(WXgݒlǂݍ)
static
BOOL
IsForceHookOffHook()
{
	BOOL	bRet;
	DWORD	dwValue = 0;

	bRet = FALSE;

	if (ReadRegDWORD(HKEY_CURRENT_USER, HOOKKEYHOOK_SETTING_REGKEY, HOOKKEYHOOK_FORCEHOOK_OFFHOOK, &dwValue)) {
		if (dwValue != 0) {
			bRet = TRUE;
		}
	}

	return bRet;
}


// dbAvőOʂɏoĂ邩H
static
BOOL
IsDenwaActive()
{
	BOOL	bRet;
	HWND	hWnd;
	TCHAR	szCaption[32];

	bRet = FALSE;

	hWnd = GetForegroundWindow();
	if (hWnd != NULL) {
		memset(szCaption, 0, sizeof(szCaption));
		GetWindowText(hWnd, szCaption, sizeof(szCaption)/sizeof(szCaption[0]));
		if (_tcscmp(szCaption, DENWA_WINDOW_TITLE) == 0) {
			bRet = TRUE;
		}
	}

	return bRet;
}


// db(M)H ...
static
BOOL
IsLockPhone()
{
	BOOL	bRet;
	DWORD	dwValue = 0;

	bRet = FALSE;

	if (ReadRegDWORD(HKEY_CURRENT_USER, SHPHONEAPP_REG_PATH, LOCKPHONE_REG_VALUE_NAME, &dwValue)) {
		if (dwValue != 0) {
			bRet = TRUE;
		}
	}

	return bRet;
}


// L[bNH
static
BOOL
IsKeyLock()
{
	BOOL	bRet;
	DWORD	dwValue = 0;

	bRet = FALSE;

	if (ReadRegDWORD(HKEY_CURRENT_USER, PHONESTATUS_REG_KEY, PHONESTATUS0_REG_VALUE_NAME, &dwValue)) {
		if (dwValue != 0) {
			bRet = TRUE;
		}
	}

	return bRet;
}


// w肵t@Cst@CH(gq݂̂Ŕf)
static
BOOL
IsExecutableFile(
	LPTSTR	pFileName
)
{

#define	HOOKKEYHOOK_EXECUTABLE_SUFFIX	_T(".exe")

	BOOL	bRet;
	DWORD	dwSuffixLen = sizeof(HOOKKEYHOOK_EXECUTABLE_SUFFIX)/sizeof(TCHAR) - 1;

	bRet =  FALSE;

	if (pFileName != NULL) {
		DWORD	dwFilePathLen = _tcslen(pFileName);
		if (dwFilePathLen >= dwSuffixLen) {
			if (_tcsicmp(pFileName + dwFilePathLen - dwSuffixLen, HOOKKEYHOOK_EXECUTABLE_SUFFIX) == 0) {
				bRet = TRUE;
			}
		}
	}

	return bRet;
}


static
BOOL
ExecCommand(
	LPTSTR	pStr,
	LPTSTR	pArg
)
{
	int		i;
	DWORD	dwID;
	BOOL	bFound;
	BOOL	bRet;
	struct {
		LPTSTR	pCmdStr;
		DWORD	dwCmdID;
	} convTable[] = {
		{	HOOKKEYHOOK_CMDSTR_SENDKEY,	HOOKKEYHOOK_CMD_SENDKEY	},
		{	HOOKKEYHOOK_CMDSTR_ONHOOK,	HOOKKEYHOOK_CMD_ONHOOK	},
		{	HOOKKEYHOOK_CMDSTR_OFFHOOK,	HOOKKEYHOOK_CMD_OFFHOOK	},
	};

	bRet = FALSE;

	if (pStr == NULL) {
		return FALSE;
	}

	bFound = FALSE;
	for (i = 0; i < sizeof(convTable)/sizeof(convTable[0]); i++) {
		if (_tcsicmp(convTable[i].pCmdStr, pStr) == 0) {
			dwID = convTable[i].dwCmdID;
			bFound = TRUE;
			break;
		}
	}

	if (bFound) {
		switch(dwID) {
		case HOOKKEYHOOK_CMD_SENDKEY:
			// L[R[h𔭍s
			if (pArg != NULL) {
				int		nNumSeq = 0;
				DWORD	dwKeySeq[MAX_KEYSEQNUM];
				LPTSTR	pToken = NULL;
				TCHAR	szTokens[] = _T(" ");

				// IvV̉
				pToken = _tcstok(pArg, szTokens);
				while (pToken != NULL) {
					dwKeySeq[nNumSeq] = _tcstoul(pToken, NULL, 0);
					nNumSeq++;
					if (nNumSeq >= MAX_KEYSEQNUM) {
						break;
					}
					pToken = _tcstok(NULL, szTokens);
				}

				if (nNumSeq > 0) {
					// L[_E̔s
					for (i = 0; i < nNumSeq; i++) {
						keybd_event((BYTE)dwKeySeq[i], 0, KEYEVENTF_SILENT, 0); 
					}
					// L[Abv̔s
					for (i = nNumSeq - 1; i >= 0 ; i--) {
						keybd_event((BYTE)dwKeySeq[i], 0, KEYEVENTF_KEYUP|KEYEVENTF_SILENT, 0);
					}

					bRet = TRUE;
				}
			}
			break;

		case HOOKKEYHOOK_CMD_ONHOOK:
			// IWiOnHooks
			CHookKeyHook::OnHook();
			bRet = TRUE;
			break;

		case HOOKKEYHOOK_CMD_OFFHOOK:
			// IWiOffHooks
			CHookKeyHook::OffHook();
			bRet = TRUE;
			break;
		}
	}

	return bRet;
}

// [U`̃ANVs
static
BOOL
ExecUserAction(
	LPTSTR	szCmdValueName,
	LPTSTR	szArgValueName
)
{
	BOOL	bRet;
	LONG	lResult;
	HKEY	hKey = NULL;

	bRet = FALSE;	// default return value

	lResult = RegOpenKeyEx(HKEY_CURRENT_USER, HOOKKEYHOOK_SETTING_REGKEY, 0, KEY_ALL_ACCESS, &hKey);

	if (lResult == ERROR_SUCCESS) {
		TCHAR	szPath[MAX_PATH+1];
		TCHAR	szArg[MAX_PATH+1];
		DWORD	dwType = 0;
		DWORD	dwSize = 0;

		memset(szPath, 0, sizeof(szPath));
		dwSize = sizeof(szPath);
		lResult = RegQueryValueEx(hKey, szCmdValueName, NULL, &dwType, (LPBYTE)szPath, &dwSize);
		if (lResult == ERROR_SUCCESS && _tcslen(szPath) != 0) {

			if (szPath[0] == _T('\\')) {
				// t@Cw肳ꂽꍇ

				if (IsExecutableFile(szPath)) {
					// st@C̏ꍇ

					BOOL	bCreateSucc = FALSE;
					PROCESS_INFORMATION pi;

					memset(&pi, 0, sizeof(pi));

					memset(szArg, 0, sizeof(szArg));
					dwSize = sizeof(szArg);
					lResult = RegQueryValueEx(hKey, szArgValueName, NULL, &dwType, (LPBYTE)szArg, &dwSize);
					if (lResult == ERROR_SUCCESS && _tcslen(szArg) != 0) {
						bCreateSucc = CreateProcess(szPath, szArg, NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi);
					}
					else {
						bCreateSucc = CreateProcess(szPath, NULL, NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi);
					}

					if (bCreateSucc) {
						CloseHandle(pi.hThread);
						CloseHandle(pi.hProcess);
					}

					bRet = TRUE;
				}
				else {
					// st@CłȂȂC֘AtꂽAvŎs
					SHELLEXECUTEINFO	sei;

					ZeroMemory(&sei, sizeof(SHELLEXECUTEINFO));

					sei.cbSize = sizeof(sei);
					sei.lpVerb = _T("Open");
					sei.lpFile = szPath;

					ShellExecuteEx(&sei);

					bRet = TRUE;
				}
			}
			else {

				memset(szArg, 0, sizeof(szArg));
				dwSize = sizeof(szArg);
				lResult = RegQueryValueEx(hKey, szArgValueName, NULL, &dwType, (LPBYTE)szArg, &dwSize);
				if (lResult == ERROR_SUCCESS) {
					ExecCommand(szPath, szArg);
				}
				else {
					ExecCommand(szPath, NULL);
				}

				bRet = TRUE;
			}
		}

		RegCloseKey(hKey);
		hKey = NULL;
	}

	return bRet;
}


// ʘbEIbL[Ȃǂ̃tbNvV[W
static
void
HookKeyHookProc(
	DWORD	dwAction,
	void*	pData
)
{
	HWND	hWnd;

	hWnd = (HWND) pData;
	if (hWnd != NULL) {
		switch(dwAction) {
		case HKH_HOOK_ONHOOK:
			// OnHookKey(IbL[)
			if (!IsForceHookOnHook() && (IsLockPhone() || IsDenwaActive())) {
				// M  dbAvANeBuȏꍇ

				// IWiOnHook̎s
				CHookKeyHook::OnHook();
			}
			else {
				if (!IsKeyLock()) {
					// L[bNł͂Ȃ
					PostMessage(hWnd, WM_NOTIFY_HKHEVENT, HKH_HOOK_ONHOOK, 0);
				}
			}
			break;

		case HKH_HOOK_OFFHOOK:
			// OffHookKey(ʘbL[)
			if (!IsForceHookOffHook() && (IsLockPhone() || IsDenwaActive())) {
				// M  dbAvANeBuȏꍇ

				// IWiOffHook̎s
				CHookKeyHook::OffHook();
			}
			else {
				if (!IsKeyLock()) {
					// L[bNł͂Ȃ
					PostMessage(hWnd, WM_NOTIFY_HKHEVENT, HKH_HOOK_OFFHOOK, 0);
				}
			}
			break;

		case HKH_HOOK_SLIDEOPEN:
			// SlideOpen(L[{[hJ)
			PostMessage(hWnd, WM_NOTIFY_HKHEVENT, HKH_HOOK_SLIDEOPEN, 0);
			break;

		case HKH_HOOK_SLIDECLOSE:
			// SlideClose(L[{[h)
			PostMessage(hWnd, WM_NOTIFY_HKHEVENT, HKH_HOOK_SLIDECLOSE, 0);
			break;
		}

	}
}

static
ATOM
MyRegisterClass(
	HINSTANCE	hInstance,
	LPTSTR		szWindowClass
)
{
	WNDCLASS	wc;

    wc.style			= 0;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= 0;
    wc.hCursor			= 0;
    wc.hbrBackground	= 0;
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= szWindowClass;

	return RegisterClass(&wc);
}


// _uNbNɎgp鎞ԊԊu擾
static
DWORD
GetPressPeriod()
{
	DWORD	dwPeriod = 0;

	if (!ReadRegDWORD(HKEY_CURRENT_USER, HOOKKEYHOOK_SETTING_REGKEY, HOOKKEYHOOK_PRESS_PERIOD, &dwPeriod)) {
		dwPeriod = HOOKKEYHOOK_DEFAULT_PERIOD;
	}

	return dwPeriod;
}

// N-ClickŃAvN邩H
static
BOOL
IsCanNthClick(
	BOOL	bOnHookKey,
	DWORD	dwTime
)
{
	BOOL	bRet = FALSE;
	TCHAR	szRegValueName[32];
	HKEY	hKey = NULL;
	LONG	lResult;

	if (bOnHookKey) {
		// OnHookKey̏ꍇ
		wsprintf(szRegValueName, HOOKKEYHOOK_ONHOOK_NTH_PATH, dwTime);
	}
	else {
		// OffHookKey̏ꍇ
		wsprintf(szRegValueName, HOOKKEYHOOK_OFFHOOK_NTH_PATH, dwTime);
	}

	lResult = RegOpenKeyEx(HKEY_CURRENT_USER, HOOKKEYHOOK_SETTING_REGKEY, 0, KEY_ALL_ACCESS, &hKey);

	if (lResult == ERROR_SUCCESS) {
		DWORD	dwType = 0;
		DWORD	dwSize = 0;

		lResult = RegQueryValueEx(hKey, szRegValueName, NULL, &dwType, NULL, &dwSize);
		if (lResult == ERROR_SUCCESS) {
			bRet = TRUE;
		}

		RegCloseKey(hKey);
		hKey = NULL;
	}

	return bRet;
}


static
void
ExecHookKeyUserAction(
	BOOL	bOnHookKey,
	DWORD	dwTime
)
{
	if (dwTime == 1) {
		if (bOnHookKey) {
			if (!ExecUserAction(HOOKKEYHOOK_ONHOOK_PATH, HOOKKEYHOOK_ONHOOK_ARG)) {
				CHookKeyHook::OnHook();
			}
		}
		else {
			if (!ExecUserAction(HOOKKEYHOOK_OFFHOOK_PATH, HOOKKEYHOOK_OFFHOOK_ARG)) {
				CHookKeyHook::OffHook();
			}
		}
	}
	else {
		TCHAR szRegCmdValueName[32];
		TCHAR szRegArgValueName[32];

		if (bOnHookKey) {
			wsprintf(szRegCmdValueName, HOOKKEYHOOK_ONHOOK_NTH_PATH, dwTime);
			wsprintf(szRegArgValueName, HOOKKEYHOOK_ONHOOK_NTH_ARG, dwTime);
		}
		else {
			wsprintf(szRegCmdValueName, HOOKKEYHOOK_OFFHOOK_NTH_PATH, dwTime);
			wsprintf(szRegArgValueName, HOOKKEYHOOK_OFFHOOK_NTH_ARG, dwTime);
		}

		ExecUserAction(szRegCmdValueName, szRegArgValueName);	
	}

}

static
LRESULT
CALLBACK
WndProc(
	HWND	hWnd,
	UINT	message,
	WPARAM	wParam,
	LPARAM	lParam
)
{

	static CHookKeyHook	s_hookKeyHook;
	static DWORD s_dwOnHookCnt = 0;
	static DWORD s_dwOffHookCnt = 0;
	static DWORD s_dwOnHookPressPeriod = HOOKKEYHOOK_DEFAULT_PERIOD;
	static DWORD s_dwOffHookPressPeriod = HOOKKEYHOOK_DEFAULT_PERIOD;

	switch (message) 
	{
		case WM_CREATE:
			{
				BOOL	bHook = FALSE;

				// OnHook/OffHookL[̃tbN
				bHook = s_hookKeyHook.StartHook(HKH_HOOK_ONHOOK|HKH_HOOK_OFFHOOK|HKH_HOOK_SLIDEOPEN|HKH_HOOK_SLIDECLOSE, HookKeyHookProc, hWnd);
				if (!bHook) {
					return -1;
				}
			}
			break;

		case WM_CLOSE:
			DestroyWindow(hWnd);
			break;

		case WM_DESTROY:
			{
				KillTimer(hWnd, TIMERID_ONHOOK);
				KillTimer(hWnd, TIMERID_OFFHOOK);

				// OnHook/OffHookL[̃tbN̉
				s_hookKeyHook.StopHook();

				PostQuitMessage(0);
			}
			break;

		case WM_NOTIFY_HKHEVENT:
			{
				switch(wParam) {
				case HKH_HOOK_ONHOOK:
					{
						// IbL[
						s_dwOnHookCnt++;

						if (IsCanNthClick(TRUE, s_dwOnHookCnt + 1)) {
							// ɂ1IbL[Ƃ̃ANV`Ă
							if (s_dwOnHookCnt == 1) {
								s_dwOnHookPressPeriod = GetPressPeriod();
							}
							
							SetTimer(hWnd, TIMERID_ONHOOK, s_dwOnHookPressPeriod, NULL);
						}
						else {
							// ɂ1IbL[Ƃ̃ANV͒`ĂȂ̂ŁCsׂANVmD
							KillTimer(hWnd, TIMERID_ONHOOK);

							ExecHookKeyUserAction(TRUE, s_dwOnHookCnt);

							s_dwOnHookCnt = 0;
							s_dwOnHookPressPeriod = HOOKKEYHOOK_DEFAULT_PERIOD;
						}
					}
					break;

				case HKH_HOOK_OFFHOOK:
					{
						// ʘbL[

						s_dwOffHookCnt++;

						if (IsCanNthClick(FALSE, s_dwOffHookCnt + 1)) {
							// ɂ1ʘbL[Ƃ̃ANV`Ă
							if (s_dwOffHookCnt == 1) {
								s_dwOffHookPressPeriod = GetPressPeriod();
							}
							
							SetTimer(hWnd, TIMERID_OFFHOOK, s_dwOffHookPressPeriod, NULL);
						}
						else {
							// ɂ1ʘbL[Ƃ̃ANV͒`ĂȂ̂ŁCsׂANVmD
							KillTimer(hWnd, TIMERID_OFFHOOK);

							ExecHookKeyUserAction(FALSE, s_dwOffHookCnt);

							s_dwOffHookCnt = 0;
							s_dwOffHookPressPeriod = HOOKKEYHOOK_DEFAULT_PERIOD;
						}
					}
					break;

				case HKH_HOOK_SLIDEOPEN:
					// L[{[hJ
					ExecUserAction(HOOKKEYHOOK_SLIDEOPEN_PATH, HOOKKEYHOOK_SLIDEOPEN_ARG);
					break;

				case HKH_HOOK_SLIDECLOSE:
					// L[{[h
					ExecUserAction(HOOKKEYHOOK_SLIDECLOSE_PATH, HOOKKEYHOOK_SLIDECLOSE_ARG);
					break;
				}
			}
			break;

		case WM_TIMER:
			if (wParam == TIMERID_ONHOOK) {
				KillTimer(hWnd, TIMERID_ONHOOK);

				ExecHookKeyUserAction(TRUE, s_dwOnHookCnt);

				s_dwOnHookCnt = 0;
				s_dwOnHookPressPeriod = HOOKKEYHOOK_DEFAULT_PERIOD;
			}
			else if (wParam == TIMERID_OFFHOOK) {
				KillTimer(hWnd, TIMERID_OFFHOOK);

				ExecHookKeyUserAction(FALSE, s_dwOffHookCnt);

				s_dwOffHookCnt = 0;
				s_dwOffHookPressPeriod = HOOKKEYHOOK_DEFAULT_PERIOD;
			}
			else {
				return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
			break;
	}

	return 0;
}

static
DWORD
WINAPI
WindowThread(void* pParam)
{
	if (pParam != NULL) {
		CHookKeyHookApp* pHKHApp	= NULL;
		HMODULE	hModule				= NULL;
		HWND	hWnd				= NULL;
		
		pHKHApp = (CHookKeyHookApp*)pParam;
		hModule = pHKHApp->GetModuleHandle();

		MyRegisterClass(hModule, HOOKKEYHOOK_WINDOW_CLASS);
		hWnd = CreateWindow(HOOKKEYHOOK_WINDOW_CLASS, HOOKKEYHOOK_WINDOW_TITLE, 0, 0, 0, 0, 0, NULL, NULL, hModule, NULL);

		if (hWnd != NULL) {
			MSG		msg;

			// Window쐬ʒm
			pHKHApp->m_bWndCreateSucc = TRUE;
			SetEvent(pHKHApp->m_hWndCreateEvent);

			// bZ[W[v
			while (GetMessage(&msg, hWnd, 0, 0)) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
		else {
			// Window쐬sʒm
			pHKHApp->m_bWndCreateSucc = FALSE;
			SetEvent(pHKHApp->m_hWndCreateEvent);
		}
	}

	return 0;
}

CHookKeyHookApp::CHookKeyHookApp()
{
	m_bInitialized		= FALSE;
	m_hModule			= NULL;
	m_hThread			= NULL;
	m_hWndCreateEvent	= NULL;
	m_bWndCreateSucc	= FALSE;	

}

CHookKeyHookApp::~CHookKeyHookApp()
{
	if (m_hThread != NULL) {
		this->Stop();
	}

	if (m_bInitialized) {
		this->Terminate();
	}
}

BOOL
CHookKeyHookApp::Initialize(
	HMODULE	hModule
)
{
	BOOL	bRet;
	HANDLE	hEvent;

	bRet = FALSE;

	if (m_bInitialized) {
		// ɏς
		return FALSE;
	}

	hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
	if (hEvent != NULL) {

		m_hModule = hModule;
		m_hWndCreateEvent = hEvent;

		m_bInitialized = TRUE;

		bRet = TRUE;
	}

	return bRet;
}

BOOL
CHookKeyHookApp::Terminate()
{
	if (!m_bInitialized) {
		// ̏ꍇ
		return FALSE;
	}

	if (m_hThread != NULL) {
		// Startς݂ȂStopĂ
		this->Stop();
	}

	if (m_hWndCreateEvent != NULL) {
		CloseHandle(m_hWndCreateEvent);
		m_hWndCreateEvent = NULL;
	}

	m_bWndCreateSucc	= FALSE;
	m_hModule			= NULL;
	m_bInitialized		= FALSE;
	
	return TRUE;
}

BOOL
CHookKeyHookApp::Start()
{
	BOOL	bRet;
	HANDLE	hThread;
	DWORD	dwThreadID;

	bRet = FALSE;

	if (!m_bInitialized) {
		// ̏ꍇ
		return FALSE;
	}

	if (m_hThread != NULL) {
		// Startς݂̏ꍇ
		return FALSE;
	}

	m_bWndCreateSucc = FALSE;
	hThread = CreateThread(NULL, 0, WindowThread, this, 0, &dwThreadID);
	if (hThread != NULL) {

		// Window쐬̐Esʒm܂ő҂
		WaitForSingleObject(m_hWndCreateEvent, INFINITE);

		if (m_bWndCreateSucc) {
			// Window쐬
			m_hThread = hThread;
			bRet = TRUE;
		}
		else {
			// Window쐬s
			WaitForSingleObject(hThread, INFINITE);
			CloseHandle(hThread);
			hThread = NULL;
		}
	}
	
	return bRet;
}

BOOL
CHookKeyHookApp::Stop()
{
	BOOL	bRet;
	HWND	hWnd;

	bRet = FALSE;

	if (!m_bInitialized) {
		// ̏ꍇ
		return FALSE;
	}

	if (m_hThread == NULL) {
		// StartĂȂꍇ
		return FALSE;
	}

	hWnd = FindWindow(HOOKKEYHOOK_WINDOW_CLASS, HOOKKEYHOOK_WINDOW_TITLE);
	if (hWnd != NULL) {

		// ThreadIv
		PostMessage(hWnd, WM_CLOSE, 0, 0);

		WaitForSingleObject(m_hThread, INFINITE);
		CloseHandle(m_hThread);
		m_hThread = NULL;

		bRet = TRUE;
	}
	else {
		if (TerminateThread(m_hThread, 0)) {
			WaitForSingleObject(m_hThread, INFINITE);
		}
		CloseHandle(m_hThread);
		m_hThread = NULL;
	}

	return bRet;
}


HMODULE
CHookKeyHookApp::GetModuleHandle()
{
	return m_hModule;
}