// main.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include "HookKeyHookApp.h"
#include "Util.h"

/* Defines */
#define	HOOKKEYHOOK_MUTEX_NAME		_T("HookKeyHook App Mutex")
#define HOOKKEYHOOK_STOPEVENT_NAME	_T("HookKeyHook App Stop Event")

int
WINAPI
WinMain(
	HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPTSTR    lpCmdLine,
	int       nCmdShow
)
{
	HANDLE	hMutex		= NULL;
	HANDLE	hStopEvent	= NULL;
	CHookKeyHookApp		hkhApp;

	// dN`FbN
	hMutex = CreateMutex(NULL, TRUE, HOOKKEYHOOK_MUTEX_NAME);
	if (hMutex != NULL) {
		if (GetLastError() == ERROR_ALREADY_EXISTS) {
			int		iRet;

			iRet = Util_MessageBox(NULL, hInstance, IDS_HKH_CONFIRM, IDS_HKH_CAPTION, MB_YESNO|MB_ICONQUESTION|MB_SETFOREGROUND);

			if (iRet == IDYES) {

				hStopEvent = CreateEvent(NULL, FALSE, FALSE, HOOKKEYHOOK_STOPEVENT_NAME);
				if (hStopEvent != NULL) {
					SetEvent(hStopEvent);
					CloseHandle(hStopEvent);
					hStopEvent = NULL;
				}
			}

			CloseHandle(hMutex);
			hMutex = NULL;
			return FALSE;
		}
	}
	else {
		return FALSE;
	}


	hStopEvent = CreateEvent(NULL, FALSE, FALSE, HOOKKEYHOOK_STOPEVENT_NAME);
	if (hStopEvent != NULL) {

		if (hkhApp.Initialize(hInstance)) {
			if (hkhApp.Start()) {
				WaitForSingleObject(hStopEvent, INFINITE);

				hkhApp.Stop();
			}
			else {
				Util_MessageBox(NULL, hInstance, IDS_HKH_CANNOTHOOK, IDS_HKH_CAPTION, MB_OK|MB_ICONERROR);
			}

			hkhApp.Terminate();
		}

		CloseHandle(hStopEvent);
		hStopEvent = NULL;
	}

	ReleaseMutex(hMutex);
	CloseHandle(hMutex);
	hMutex = NULL;
	return FALSE;
}
